/* js */
import 'core-js/stable'
import $ from 'jquery'
import CanvasView from './_canvas'

/* style */
import './_style'



// タイトルをspanで囲う
const spanText = () => {
  const nodeList = document.querySelectorAll('.js-title');
  const spanList = [...nodeList].reduce((acc, cur) => {
    const txt = cur.textContent;
    const txtFormat = `<span>${[...txt].join('</span><span>')}</span>`;

    // HTMLを書き換え
    cur.innerHTML = txtFormat;

    // スタイル指定
    [...cur.children].forEach(node => {
      const vectorX = 0.5 < Math.random() ? 1 : -1;
      const vectorY = 0.5 < Math.random() ? 1 : -1;
      let array = [];

      const rx = Math.random() * 360 * vectorX;
      array.push(`rotateX(${rx}deg)`);

      const ry = Math.random() * 360 * vectorY;
      array.push(`rotateY(${ry}deg)`);

      const rz = Math.random() * 360 * vectorX;
      array.push(`rotateZ(${rz}deg)`);

      const tx = Math.random() * 100 * vectorX;
      array.push(`translateX(${tx}px)`);

      const ty = Math.random() * 100 * vectorY;
      array.push(`translateY(${ty}px)`);

      const tz = Math.random() * 100;
      array.push(`translateZ(${tz}px)`);

      node.style.transform = array.join(' ');
      node.style.opacity = 0;
    });

    acc.push(...cur.children);
    return acc;
  }, []);

  return spanList;
}

// 初期化
const init = () => {
  const spanAll = spanText();
  const view = new CanvasView($('#canvas')[0], spanAll, () => new Point(spanAll));

  // DOMを表示
  $('#wrapper').addClass('is-init');
}
window.addEventListener('load', () => init());
