const webpack = require('webpack');
const UglifyJSPlugin = require('uglifyjs-webpack-plugin');

module.exports = {
  mode: 'production',
  devtool: false,
  optimization: {
    minimizer: [
      new UglifyJSPlugin({
        extractComments: false,
        sourceMap: false,
        uglifyOptions: {
          output: {
            comments: /^\**!|@preserve|@license|@cc_on/i
          },
          compress: { drop_console: true }
        }
      })
    ]
  }
};
